var unsorted_abc = [];

function transliterate(output, abc_from, abc_to, unsorted_abc) {
    var noSymbol = '';
    var unknowing_symbol = '-';
    var removeSymbol = '====';
    //output = output.replace(new RegExp('>|<|\'|\’', 'g'), '');
    var abc = unsorted_abc.sort(function(a, b) {
        if (a[abc_from].length === b[abc_from].length) return 0;
        else return (a[abc_from].length > b[abc_from].length) ? -1 : 1;
    });
    for(var idx=0; idx<abc.length; idx++) {
        if(
            abc[idx][abc_from].length != 0
            //&& abc[i][to] != 0
         ) {
            var replace_string = abc[idx][abc_from];
            //pattern = replace_string.replace(/\\n/g, '\n');
            //pattern = '(' + replace_string.replace(/\\n/g, '\n') + ')' + '(?![^<]*>|[^<>]*</)';
            pattern = '(' + replace_string.replace(/\\n/g, '\n') + ')';
            var re = new RegExp(pattern, 'g');
            
            if(abc[idx][abc_to] == '-') abc[idx][abc_to] = '';
            
            if(abc[idx][abc_to] != noSymbol && abc[idx][abc_to] != removeSymbol) {
                newSubstr = '<#>' + abc[idx][abc_to].replace(/\\n/g, '\n') + '</#>'
                output = output.replace(re, newSubstr);
            }
            else if(abc[idx][abc_to] == removeSymbol) {
                output = output.replace(re, '');
            }
            /* else {
                output = output.replace(re, '');
            }*/
        }
    }
    output = output.replace(/<#>/g,'');
    output = output.replace(/<\/#>/g,'');
    return output;
}

function doSomething(json) {
    var abc_from = 0;
    var abc_to = 1;
    
    for (var key in json) {
        var item = json[key];
        unsorted_abc.push(item);
    }
    unsorted_abc.shift(); // remove array of langs
    
    document.querySelectorAll('*').forEach(function(node) {
        //console.dir (node);
        if(node.tagName != 'HTML' &&
                node.tagName != 'HEAD' &&
                node.tagName != 'SCRIPT' &&
                node.tagName != 'STYLE' &&
                node.tagName != 'META' &&
                node.tagName != 'BODY' &&
                node.tagName != 'FORM' &&
                node.tagName != 'NOSCRIPT') {
            node.innerHTML = transliterate(node.innerHTML, abc_from, abc_to, unsorted_abc);
        } else {
            //console.log ("It's a script! [some other stuff]");
        }
    });
}

function getMatrix(type_of_abc_from, type_of_abc_to, iso639_3) {
    const url = chrome.runtime.getURL('json/matrix_turkic_sounds_' + type_of_abc_from + '_' + type_of_abc_to + '_' + iso639_3 + '.json');
    
    fetch(url)
        .then((response) => response.json()) //assuming file contains json
        .then((json) => doSomething(json));
    console.log (url);
}
;

  chrome.storage.sync.get('language', function(data) {
    getMatrix(data.language.type_from, data.language.type_to, data.language.iso639_3);
  });
  
//https://speak.tatar/static/language/js/transliterate.js
